package LD28 
{
	import org.flixel.*;
	import mx.collections.ArrayCollection;
	/**
	 * ...
	 * @author Vanja Radenovic
	 */
	public class Legislator
	{
		
		public var preferences:Vector.<Preference> = new Vector.<Preference>();
				
		private var x:int;
		private var y:int;
		
		public var support:int = 0;
		private var previousSupport:int = 0;
		private var tempSupport:int = 0; // for temporarily storing the support value while doing legislators
		
		private var sprite:FlxSprite;
		private var nameTxt:FlxText;
		private var second:FlxSprite;
		private var boo:FlxSprite;
		
		public var preferencesTxt:Vector.<FlxText> = new Vector.<FlxText>();
			
		public var name:String;
		
		public function Legislator(x:int, y:int, name:String) 
		{
			this.x = x;
			this.y = y;
			this.name = name;
			
			sprite = new FlxSprite(x, y);
			//sprite.makeGraphic(60, 80, 0xffffffff);
			sprite.loadGraphic(Content.PortraitImg, true, false, 60, 80);
			sprite.randomFrame();
			nameTxt = new FlxText(x, y + 80, 60, name);
			nameTxt.setFormat("MainFont", 10, 0xffffffff, "center");
			
			second = new FlxSprite(x, y+61, Content.SecondImg); 
			second.visible = false;
			boo = new FlxSprite(x, y+61, Content.BooImg);
			boo.visible = false;
			
			FlxG.state.add(sprite);
			FlxG.state.add(nameTxt);
			FlxG.state.add(second);
			FlxG.state.add(boo);
			
		}
		
		public function addPreference(ID:int, type:int, value:int): void
		{
			var preference:Preference = new Preference (ID, type, value);
			var preferenceNo:int = preferences.push(preference);
			
			var preferenceTxt:FlxText = new FlxText(x-30, y + 80 + ((preferenceNo) * 11), 120, preference.toString());
			preferenceTxt.setFormat("MainFont", 10, 0xffffffff, "center");
			FlxG.state.add(preferenceTxt);
			
			preferencesTxt.push(preferenceTxt);
		}
		
		// each update test out how the legislators like the words
		public function testWords():void
		{
			
			// first clear all the preference text colors at this point 
			for each (var preferenceTxt:FlxText in preferencesTxt)
			{
				preferenceTxt.color = 0xffffffff;
				
			}
			previousSupport = support;
			// clear the support
			support = 0;
			tempSupport = 0;
			
			var i:int = 0;
			for each (var preference:Preference in preferences)
			{
				if (preference.isWord()) // if its a word
				{
					if (TenSecondsGame.wordsInPlay.contains(preference.ID)) // and it selected
					{
						support += preference.value;
						// highlight
						if (preference.value > 0) 
						{
							preferencesTxt[i].color = 0xff00ff00;
						}
						else // negative
						{
							preferencesTxt[i].color = 0xffff0000;
						}
					}
				}
				i ++;
			}
			
		}
		
		// after all the words are added up test out the relations
		public function testLegislators():void
		{
			var i:int = 0;
			for each (var preference:Preference in preferences)
			{
				if (!preference.isWord()) // if its a leg
				{
					var legislator:Legislator = (HallState(FlxG.state)).legislators[preference.ID];
					trace (legislator.name);
					tempSupport += (legislator.support * preference.value);
					
					if ((legislator.support * preference.value) > 0)
					{
						preferencesTxt[i].color = 0xff00ff00;
					}
					else if ((legislator.support * preference.value) < 0)
					{
						preferencesTxt[i].color = 0xffff0000;
					}
					
				}
				i ++;
			}
			
		}
		
		public function getRandomYeah():Class
		{
			var randomNo:int = (FlxG.random() * 4);
			
			switch (randomNo)
			{
				case 0:
					return Content.Yeah1Snd;
					break;
				case 1:
					return Content.Yeah2Snd;
					break;
				case 2:
					return Content.Yeah3Snd;
					break;
				case 3:
					return Content.Yeah4Snd;
					break;
				default:
					return Content.Yeah1Snd;
			}
			
		}
		
		public function getRandomBoo():Class
		{
			var randomNo:int = (FlxG.random() * 4);
			
			switch (randomNo)
			{
				case 0:
					return Content.Boo1Snd;
					break;
				case 1:
					return Content.Boo2Snd;
					break;
				case 2:
					return Content.Boo3Snd;
					break;
				case 3:
					return Content.Boo4Snd;
					break;
				default:
					return Content.Boo1Snd;
			}
			
		}
		
		// should be called after all the support is worked out
		public function updateFinal():int
		{
			support += tempSupport;
			// also should display a "second" message
			trace(name + " " + support);
			
			if (support >= 1)
			{
				second.visible = true;
				boo.visible = false;
				if (previousSupport < 1)
				{
					FlxG.play(getRandomYeah());
				}
				return 1
				
			}
			else if (support <= -1)
			{
				second.visible = false;
				boo.visible = true;
				
				return 0;
			}
			else
			{
				second.visible = false;
				boo.visible = false;
				if (previousSupport > -1)
				{
					FlxG.play(getRandomBoo());
				}
				return 0;
				
			}
		}
		
	}

}