package LD28 
{
	import org.flixel.*;
	/**
	 * ...
	 * @author Vanja Radenovic
	 */
	public class MainState extends FlxState 
	{
		
		private var startBtn:FlxButton;
		private var instructionBtn:FlxButton;
		private var creditsBtn:FlxButton;
		
		private var background:FlxSprite;
		
		private var instructionState:int = -1;
		private var instructionSlide1:FlxSprite;
		private var instructionSlide2:FlxSprite;
		
		private var creditsState:int = -1;
		private var creditsSlide:FlxSprite;
		
		private var whiteSnake:FlxSprite;
		private var seenLogo:Boolean;
		
		private var timerSet:int = 240;
		private var timer:int = timerSet;
		
		override public function create():void 
		{
			
			ID = 2;
			FlxG.mouse.show();
			
			background = new FlxSprite(0, 0, Content.MainBackgroundImg);
			add(background);
			
			instructionBtn = new FlxButton(450, 200, "Instruction", instructionBtnClick, 120);
			instructionBtn.loadGraphic(Content.MainButtonImg);
			instructionBtn.label.setFormat("MainFont", 14, 0xff000000, "center");
			add(instructionBtn);
			
			startBtn = new FlxButton(450, 260, "Start", startBtnClick, 120);
			startBtn.loadGraphic(Content.MainButtonImg);
			startBtn.label.setFormat("MainFont", 14, 0xff000000, "center");
			add(startBtn);
			
			creditsBtn = new FlxButton(450, 320, "Credits", creditBtnClick, 120);
			creditsBtn.loadGraphic(Content.MainButtonImg);
			creditsBtn.label.setFormat("MainFont", 14, 0xff000000, "center");
			add(creditsBtn);
			
			
			instructionSlide1 = new FlxSprite(0, 0, Content.IntroCardI1Img);
			instructionSlide2 = new FlxSprite(0, 0, Content.IntroCardI2Img);
			instructionSlide1.visible = false;
			instructionSlide2.visible = false;
			add(instructionSlide1);
			add(instructionSlide2);
			
			creditsSlide = new FlxSprite(0, 0, Content.CreditsImg);
			creditsSlide.visible = false;
			add(creditsSlide);
			
			whiteSnake = new FlxSprite(0, 0, Content.WhiteSnakeImg);
			add(whiteSnake);
			
			FlxG.onMouseUp = mouseClick;
		}
		
		public function mouseClick():void
		{
			if (instructionState != -1)
			{
				FlxG.play(Content.ClickSnd);
				switch (instructionState)
				{
					case 0:
						instructionSlide1.visible = false;
						instructionSlide2.visible = true;
						instructionState++;
						break;
					case 1:
						instructionSlide2.visible = false;
						instructionState = -1;
						FlxG.onMouseUp = null;
						break;
					
					
				}
				
			}
			
			if (creditsState != -1)
			{
				FlxG.play(Content.ClickSnd);
				creditsSlide.visible = false;
				FlxG.onMouseUp = null;
				creditsState = -1;
			
			}
			
			if (!seenLogo)
			{
				whiteSnake.visible = false;
				timer = -1;
				seenLogo = true;
				FlxG.onMouseUp = null;
			}
			
		}
		
		public function creditBtnClick():void
		{
			FlxG.play(Content.ClickSnd);
			creditsSlide.visible = true;
			FlxG.onMouseUp = mouseClick;
			creditsState = 0;
		}
		
		public function startBtnClick():void
		{
			FlxG.play(Content.ClickSnd);
			FlxG.switchState(new HallState);
			
		}
		
		public function instructionBtnClick():void
		{
			FlxG.play(Content.ClickSnd);
			instructionState = 0;
			instructionSlide1.visible = true;
			FlxG.onMouseUp = mouseClick;
		}
		
		override public function update():void
		{
			// add support for enter and space
			if (FlxG.keys.justPressed("ENTER") || FlxG.keys.justPressed("SPACE"))
			{
				mouseClick();
			}
			
			if (timer > 0)
			{
				timer--;
			}
			if (timer == 0)
			{
				mouseClick();
			}
			
			
			super.update();
		}
		
	}

}