package LD28 
{
	import org.flixel.*;
	/**
	 * ...
	 * @author Vanja Radenovic
	 */
	public class SpeechField 
	{
		
		private var billText:FlxText;
		
		private var UIelements:FlxGroup;
		
		private var wordChoicesUI: WordChoicesUI;
		
		private const wordButtonSizeX:int = 128;
		private const rowSize:int = 35;
		private const maxWidth:int = 450;
		private const charWidth:int = 10;
		private const middleX:int = 320;
		private const minSizeText:int = 10;
		
		public function SpeechField(wordChoicesUI: WordChoicesUI, scenarioXML:XML) 
		{
			
			this.wordChoicesUI = wordChoicesUI;
			
			UIelements = new FlxGroup();
			// generic and always the same ish
			billText = new FlxText(20, 310, 600, scenarioXML.Scenario.(@ID == TenSecondsGame.scenario).Title + "\nWhat will you say to the parliament:");
			billText.setFormat("MainFont", 15, 0xffffffff, "center");
			FlxG.state.add(billText);
			
			// dyanmic ish
			var temp:FlxButton;
			var tempTxt:FlxText;
			
			var size:int;
			var rowDivideID:int = -1;
			var sizeSecondRow:int; 
			
			var i:int;
			
			// first time around is to get the spacing right 
			for each (var componentXML:XML in scenarioXML.Scenario.(@ID == TenSecondsGame.scenario).Component)
			{
				//trace (componentXML);
				if (componentXML.Type == 1) // 1 is word box
				{
					if (rowDivideID == -1)
					{
						size = size + wordButtonSizeX;
					}
					else
					{
						sizeSecondRow = sizeSecondRow + wordButtonSizeX;
					}
				}
				else // 0 is text box
				{
					var textString:String = componentXML.Value;
					if (rowDivideID == -1)
					{
						size += (minSizeText + charWidth * textString.length);
					}
					else
					{
						sizeSecondRow = sizeSecondRow + (minSizeText + charWidth * textString.length);
					}
					
				}
				
				i++;
				//trace(size);
				if (size > 450 && rowDivideID == -1)
				{
					rowDivideID = i;
					
				}
				
				
			}
			
			i = 0;
			var rowX:int = middleX + (size/2)
			var rowY:int = 355;
			
			// second time around is to add the actual elements
			for each (componentXML in scenarioXML.Scenario.(@ID == TenSecondsGame.scenario).Component)
			{
				
				if (rowDivideID == i)
				{
					trace ("EEE");
					rowX = middleX + (sizeSecondRow/2);
					size = sizeSecondRow;
					rowY += rowSize;
				}
				
				if (componentXML.Type == 1) // 1 is word box
				{
					temp = new FlxButton(rowX - size, rowY, "?" , null, 120);
					temp.loadGraphic(Content.WordButtonImg);
					temp.label.setFormat("MainFont", 14, 0xff000000, "center");
					temp.onUpGetItself = onButtonClick;
					
					if (componentXML.Value == 0) // noun
					{
						temp.label.text = "<Noun>";
						temp.ID = 1; // to ensure unreadability this will start from 1 instea dof 0
					}
					else // 1 verb
					{
						temp.label.text = "<Verb>";
						temp.ID = 2;
					}
					
					
					UIelements.add(temp);
					size -= wordButtonSizeX;
				}
				else // 0 is text box
				{
					var textString:String = componentXML.Value;
					
					tempTxt = new FlxText(rowX - size, rowY + 5, (minSizeText + charWidth * textString.length), textString);
					tempTxt.setFormat("MainFont", 14, 0xfffffff, "center");
					UIelements.add(tempTxt);
					size -= (minSizeText + charWidth * textString.length);
				}
				
				i++;
				
					
			}
			
			
			
			
			/*
			temp = new FlxButton(150, 350, "<Noun>" , null, 120);
			temp.loadGraphic(Content.WordButtonImg);
			temp.label.setFormat("MainFont", 14, 0xff000000, "center");
			temp.ID = 1;
			temp.onUpGetItself = onButtonClick;
			UIelements.add(temp);
			
			tempTxt = new FlxText(280, 355, 80, "Will be");
			tempTxt.setFormat("MainFont", 14, 0xfffffff, "center");
			UIelements.add(tempTxt);
			
			temp = new FlxButton(360, 350, "<Verb>" , null, 120);
			temp.loadGraphic(Content.WordButtonImg);
			temp.label.setFormat("MainFont", 14, 0xff000000, "center");
			temp.ID = 2;
			temp.onUpGetItself = onButtonClick;
			UIelements.add(temp);
			*/
			
			FlxG.state.add(UIelements);
			
			
			
		}
		
		
		public function onButtonClick(button:FlxButton): void
		{
			FlxG.play(Content.ClickSnd);
			if ((button.ID) == 1) // noun
			{
				wordChoicesUI.displayText(button.label, true);
				
			}
			else // verb
			{
				wordChoicesUI.displayText(button.label, false);
				
			}
			
		}
	}

}