package LD28 
{
	import org.flixel.*;
	
	/**
	 * ...
	 * @author Vanja Radenovic
	 */
	public class WordChoicesUI 
	{
		
		private var buttons:FlxGroup;
		
		private var buttonText:FlxText;
		private var noun:Boolean;
		
		private var callback:HallState;
		
		public function WordChoicesUI(callback:HallState) 
		{
			this.callback = callback;
			
			buttons = new FlxGroup();
			var temp:FlxButton;
			
			
			for (var y:int = 0; y < 2; y++)
			{
				for (var x:int = 0; x < 5; x++)
				{
					temp = new FlxButton(x * 128, (420 + (y * 30)),"LNGWORDTEST" , null, 120);
					temp.loadGraphic(Content.WordButtonImg);
					temp.label.setFormat("MainFont", 14, 0xff000000, "center");
					//temp.ID = (x + 1) + (y * 5);
					temp.onUpGetItself = onButtonClick;
					buttons.add(temp);
					
				}
				
			}
			
			
			
			buttons.visible = false;
			FlxG.state.add(buttons);
		
		}
		
		public function onButtonClick(button:FlxButton):void
		{
			FlxG.play(Content.ClickSnd);
			// if its not one of our placeholder words
			if (TenSecondsGame.words.contains(buttonText.text))
			{
				// remove it from the list of words in play
				TenSecondsGame.wordsInPlay.removeItemAt(TenSecondsGame.wordsInPlay.getItemIndex(TenSecondsGame.words.getItemIndex(buttonText.text)));
			}
			// update the button with the selected text
			this.buttonText.text = button.label.text;
			// add the word to our list of words in play
			TenSecondsGame.wordsInPlay.addItem(TenSecondsGame.words.getItemIndex(button.label.text));
			
						
			buttons.visible = false;
			
			callback.updateLegislators();
		}
		
		public function displayText(buttonText:FlxText, noun:Boolean): void
		{
			// save for later
			this.buttonText = buttonText;
			this.noun = noun;
			// fill inteh button text wit hteh words
			var button:FlxButton;
			for (var i:int = 0; i < 10; i++)
			{
				
				button = FlxButton(buttons.members[i]);	
				if (noun)
				{
					if (TenSecondsGame.wordsInPlay.contains(i + 10))
					{
						button.label.text = "";
						button.active = false;
					}
					else
					{
						button.label.text = TenSecondsGame.words[i + 10];
						
						button.active = true;
					}
				}
				else
				{
					if (TenSecondsGame.wordsInPlay.contains(i))
					{
						button.label.text = "";
						button.active = false;
					}
					else
					{
						button.label.text = TenSecondsGame.words[i];
						
						button.active = true;
					}
				}
			}
			
			buttons.visible = true;
			
		}
		
	}

}